/*
    Copyright (C) 2006-2007 Remon Sijrier

    This file is part of Traverso

    Traverso is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA.

*/

#ifndef T_AUDIO_PLUGIN_VIEW_H
#define T_AUDIO_PLUGIN_VIEW_H


#include "TViewItem.h"
#include <QString>

class TAudioPluginPropertiesDialog;

class TAudioTrackView;
class TAudioPluginChainView;
class TAudioPlugin;
class TAudioPluginChain;

class TAudioPluginView : public TViewItem
{
    Q_OBJECT

public:
    TAudioPluginView(TAudioPluginChainView* pcv, TAudioPluginChain* chain, TAudioPlugin* plugin, int index);
    ~TAudioPluginView();

    TAudioPlugin* get_plugin();
    void set_index(int index);
    void set_moving(bool move);

    void paint(QPainter* painter, const QStyleOptionGraphicsItem *option, QWidget *widget);
    void calculate_bounding_rect();

private:
    TAudioPluginChain*	m_pluginchain;
    TAudioPlugin*         m_plugin;

    int             m_index;
    bool            m_moving;
    int             m_textwidth;
    QString         m_name;

    TAudioPluginPropertiesDialog* m_propertiesDialog;

public slots:
    TCommand* edit_properties();
    TCommand* remove_plugin();

private slots:
    void repaint();
};

#endif

//eof

